unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  BufDataset, Classes, DB, DBGrids, SysUtils, Forms, Controls, Graphics,
  Dialogs, MyNavigator;

type
  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure BufDataset1AfterCancel(DataSet: TDataSet);
    procedure BufDataset1AfterClose(DataSet: TDataSet);
    procedure BufDataset1AfterDelete(DataSet: TDataSet);
    procedure BufDataset1AfterEdit(DataSet: TDataSet);
    procedure BufDataset1AfterInsert(DataSet: TDataSet);
    procedure BufDataset1AfterOpen(DataSet: TDataSet);
    procedure BufDataset1AfterPost(DataSet: TDataSet);
    procedure BufDataset1AfterScroll(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
  private
    MyNav: TMyDBNavigatorFrame;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Den neuen DBNavigator zur Laufzeit erzeugen
  MyNav := TMyDBNavigatorFrame.Create(self);
  MyNav.Parent := self;
  MyNav.Align := alTop;
  MyNav.AutoSize := true;
  MyNav.BorderSpacing.Around := 4;
  MyNav.Dataset := BufDataset1;

  // Dataset vorbereiten
  Bufdataset1.FileName := 'test.db';
  if not FileExists(Bufdataset1.FileName) then
  begin
    BufDataset1.FieldDefs.Add('x', ftFloat);
    BufDataset1.FieldDefs.Add('y', ftFloat);
    BufDataset1.CreateDataset;

    Bufdataset1.AppendRecord([0.12, 0.36]);
    Bufdataset1.AppendRecord([0.02, 0.11]);
    Bufdataset1.AppendRecord([0.95, 0.84]);
    Bufdataset1.AppendRecord([0.57, 0.71]);
  end;
  BufDataset1.Open;
  (BufDataset1.FieldByName('x') as TFloatField).DisplayFormat := '0.000';
  (BufDataset1.FieldByName('y') as TFloatField).DisplayFormat := '0.000';
end;

// Die folgenden Eventhandler aktualisieren die Button-Zustände des Navigator
// wenn etwas am Dataset geändert wurde, ohne dass der Navigator selbst involviert
// war.
procedure TForm1.BufDataset1AfterPost(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterScroll(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterInsert(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterOpen(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterDelete(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterEdit(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterCancel(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

procedure TForm1.BufDataset1AfterClose(DataSet: TDataSet);
begin
  MyNav.UpdateBtns;
end;

end.

